#!/usr/bin/php
<?php
/******************************************************************************
	Files(WEBե붦ͭPHPץ)
	Files(WEB file share PHP script)

	
	Login processing

  	login.php

	Written by:	Takashi Miyagi

	Copyright (c) 2004-2008 Technoworks Co., Ltd. All rights reserved.

	Last Update: 2008/03/25

	Update history:

	Ver.2.4
		̤ؤ³ѤURLɽ褦ˤ
		URL for the connection to the login screen was displayed. 

	Ver.2.1
		եɲ
		The configuration file arrangement setting is added.

	Ver.2.0
		ɽʸ locale.php 褦˽
		The display character string was acquired from locale.php. 

		ʸɤλ locale.php 褦˽
		The specification of the character-code was acquired from locale.php.

		ͭԤȥ롼פˤ륢浡ǽղ
		The access control function by the group is added with the owner. 

		HTMLʬˣХʸѤʤ褦˽
		֥饦ʸɼưȽ̤˱ƶʤ褦ˤ뤿
		To make it not misidentified by the character-code automatic operation 
		identification of a browser, it was corrected that Japanese was not 
		used for the HTML part. 

	Ver.1.4 ޤǤι
	Update history to Ver.1.4
		2005/08/02	ڡإåʬ̲
					A common page header partial function is added. 

******************************************************************************/

$login_page = TRUE;

require('files_com.php');

$conf = init_files($login_page);
$mode = get_post_get_val("mode");
$return_url = get_post_get_val("return_url");

if ($return_url != "") {
	$conf["returl"] = $return_url;
}

$submit = get_post_get_val("submit");

if ($conf["LOGIN_SCRIPT"] != "") {
	$scriptname = $conf["LOGIN_SCRIPT"];
} else {
	$scriptname = "login.php";
}

if ($conf["LOGIN_TITLE"] != "") {
	$title_str = $conf["LOGIN_TITLE"];
} else {
	$title_str = get_txt("user auth");
}
$userid_str = get_txt("user id");
$passwd_str = get_txt("password");
$submit_str = get_txt("login");
$reset_str = get_txt("reset");
$cancel_str = get_txt("cancel");

$returl = "";
if (isset($conf["returl"])) {
	$returl = $conf["returl"];
}

if (referer_url_check($conf, $returl, FALSE, FALSE)) {
	put_log($conf, "Referer url is permitted : login success");

	//Ĥ줿ƤӽФʤ˥塼ޤϥե˥쥯Ȥ
	//It redirects it to permitted call former Japanese oak setting menu or
	//file list.
	if ($conf["CONFIG_DIR"] == 0) {
		//ե˥쥯Ȥ
		//It redirects it to the file list. 
		echo get_redirect_files_JavaScriptHTML($conf);
	} else {
		//˥塼˥쥯Ȥ
		//It redirects it to a set menu.
		echo get_redirect_confmenu_JavaScriptHTML($conf);
	}
	exit;
}
if (isset($conf["PASSWD_FILE"]) && $conf["PASSWD_FILE"] != "") {
	$pwdfile = $conf["PASSWD_FILE"];
} else {
	put_log($conf, "No password file : login success");

	//ѥɥե뤬̤ʤե˥쥯Ȥ
	//If the password file is a unsetting, it redirects it to the file list.
	echo get_redirect_files_JavaScriptHTML($conf);
	exit;
}
//åID(ѥɰŹ沽ΥѿȤƻ)
//Session ID is obtained. 
//(Use it as a challenge variable when the password is encrypted. )
$s_name = files_session_name();
$s_id = session_id();

?>

<HTML>
<HEAD>
<?php echo get_charset_line(); ?>
<TITLE><?php echo $conf["HEADER_TITLE"] ?></TITLE>
<SCRIPT LANGUAGE="JavaScript" SRC="md5hash.js"></SCRIPT>
<SCRIPT LANGUAGE="JavaScript">
<!--
//Login execution
function login()
{
	var	pwd;
	var	hash;
	var	join_str;
	var	send_pwd;

	//The input password is obtained.
	pwd = document.inp_form.inpstr.value;
	if (pwd.length > 0) {
<?php
if (is_md5_use($conf)) {
?>
		//The MD5 hush value of the input password is obtained.
		hash = md5hash_hexstr(pwd);

		//The MD5 hush values of session ID and the input password are united.
		join_str = "<?php echo $s_id ?>" + hash;

		//The MD5 hush value of the uniting character string is
		//assumed to be a transmission password character string.
		send_pwd = md5hash_hexstr(join_str);
<?php
} else {
?>
		//When you do not use MD5 with JavaScript when the password is input
		send_pwd = pwd;
<?php
}
?>
	} else {
		send_pwd = "";
	}
	document.inp_form.inpstr.value = "";
	document.inp_form.passwd.value = send_pwd;
	document.inp_form.mode.value = "send";
	document.inp_form.action = "<?php echo $scriptname; ?>";
	document.inp_form.target = "_top";
	document.inp_form.submit();
}
// -->
</SCRIPT>
</HEAD>
<BODY <?php echo get_body_bg_str($conf); ?>>
<CENTER>
<TABLE border=0>
	<TR>
		<TD>
			<CENTER>
				<?php
					//ڡȥΥ᡼ޤʸ
					//Image or character string in page title
					echo get_page_title_HTML($conf);
				?>
			</CENTER>
		</TD>
	</TR>
</TABLE>
<?php

//ȥ벼Υȹɽ
//Comment line display under title
if ($conf["TITLE_COMMENT_LOGIN"] != "") {
	echo "<CENTER>" . $conf["TITLE_COMMENT_LOGIN"] . "</CENTER>";
}

//裱裲ؤΥ󥯤ɽHTML
//Link HTML to return 1 and return 2 destination is generated.
echo get_return_url_HTML($conf);

echo get_header_info_HTML($conf, FALSE, FALSE, TRUE);

?>
<HR>

<?php

if ($mode != "send") {
	//ϥեɽ
	//Login input form display
?>
<form name="inp_form" method="post">
	<input type="hidden" name="mode" value="">
	<input type="hidden" name="passwd" value="">
	<input type="hidden" name="config" value="<?php echo $conf["config"] ?>">
	<input type="hidden" name="returl" value="<?php echo $returl ?>">
	<input type="hidden" name="<?php echo $s_name ?>" value="<?php echo $s_id ?>">
	<TABLE border=1><TBODY>
		<TR BGCOLOR="<?php echo $conf["LIST_TITLE_BG"] ?>">
			<TD colspan=2>
				<CENTER><B><?php echo $title_str ?></B></CENTER>
			</TD>
		</TR>
		<TR>
			<TD><B><?php echo $userid_str ?>:</B></TD>
			<TD><input name="userid" type="text" size=20 maxlength=30></TD>
		</TR>
		<TR>
			<TD><B><?php echo $passwd_str ?>:</B></TD>
			<TD><input name="inpstr" type="password" size=20 maxlength=30></TD>
		</TR>
		<TR>
			<TD colspan=2>
			<CENTER>
			<input type="button" value="<?php echo $submit_str ?>"
												onClick="login()">
			<input type="reset" value="<?php echo $reset_str ?>">
			</CENTER>
			</TD>
		</TR>
	</TBODY></TABLE>
</form>
<HR>

<?php
	//裱裲ؤΥ󥯤ɽHTML
	//Link HTML to return 1 and return 2 destination is generated.
	echo get_return_url_HTML($conf);

?>
<br>
<?php

	if ($conf["ENTRY_PAGE_DIR_URL"] != "") {
		$link_url = $conf["ENTRY_PAGE_DIR_URL"];
		$str = "<b>" . get_txt("link address to this page") . "&nbsp;:&nbsp;";
		$str .= get_return_refer_url_HTML($link_url . "/", $link_url . "/");
		echo $str;
	}
} else {
	//¹
	//Login execution

	$msg = "";
	$logmsg = "";
	$sts = FALSE;
	$fp = 0;

	$userid = get_post_get_val("userid");
	$passwd = get_post_get_val("passwd");

	if ($userid == "") {
		//桼ID̤
		//User ID unsetting
		$msg .= $userid_str . "&nbsp;" . get_txt("is not specified");
		$logmsg = "no user id";
	} elseif(! file_exists($pwdfile)) {
		if ($userid != $conf["ADMIN_USERID"]) {
			$msg .= get_txt("no password file");
			$logmsg = get_txt("no password file");
		} else {
			if (!($fp = fopen($pwdfile, "w"))) {
				$msg .= get_txt("password file cannot be created");
				$logmsg = get_txt("password file cannot be created");
			} else {
				flock($fp, 2);

				//ԤΥǥեȤΥѥɤ
				//The password of manager's default is set.
				$default_passwd = "";
				if ($conf["ADMIN_DEFAULT_PASSWD"] != "") {
					$default_passwd = md5($conf["ADMIN_DEFAULT_PASSWD"]);
				}
				$buffer = $userid . "\t" . $default_passwd . "\n";
				fputs($fp, $buffer, strlen($buffer));

				flock($fp, 3);
				fclose($fp);

				chmod($pwdfile, get_pwd_file_attr($conf));

				$sts = TRUE;
			}
		}
	} elseif (!($fp = fopen ($pwdfile, "r"))) {
		$msg .= get_txt("cannot open password file");
		$logmsg = get_txt("cannot open password file");
	} else {
		flock($fp, 2);

		$found = FALSE;

		while (!feof($fp)) {
			//ɤ߹
			//One line reading
			$buffer = fgets($fp, 4096);
			$buffer = chop($buffer);
			if (strlen($buffer) < 3) {
				//ʸʲιԤϼΤƤ
				//The line of three characters or less is thrown away.
				continue;
			}
			if (substr($buffer, 0, 1) == "#") {
				//ȹԤϥå
				//The comment line is skipped.
				continue;
			}
			//Ԥԣ¤ʬ
			//The line is divided with TAB.
			$flds = split("\t", $buffer);

			//ĤΥեɤ뤳
			//There must be two fields.
			if ($flds[0] != "") {
				if (strcmp($flds[0], $userid) == 0) {
					//桼̾
					//The user name is corresponding.
					$found = TRUE;

					//եΥѥɤMD5ϥåͤ
					//The MD5 hush value of the password under the
					//file is obtained.
					if ($flds[1] != "") {
						$pwd = $flds[1];
						if (!is_md5_use($conf)) {
							//ѥϻJavaScriptMD5Ȥʤ
							//ѥɥեˤMD5ǥϥå岽Τ
							//ϿƤ뤿ᡢӤ뤿ϤΤ
							//ǥϥå岽
							//When you do not use MD5 with JavaScript when the
							//password is input
							//Because what made a hush with MD5 is registered
							//in the password file
							//What input for the sake of comparison is made a 
							//hush here. 
							$passwd = md5($passwd);
						} else {
							// åIDȥѥMD5ϥåͤ
							//Session ID and password MD5 hush value are 
							//united.
							$pwd = $s_id . $pwd;

							//礷ʸMD5ϥåͤ
							//The MD5 hush value of the uniting character 
							//string is obtained.
							$pwd = md5($pwd);
						}
						// äMD5ϥåͤ
						//Received MD5 hush value and comparison
						if ($passwd == $pwd) {
							$sts = TRUE;
						} else {
							$msg = $passwd_str . "&nbsp;" . get_txt("is different");
							// for DEBUG
							//$msg .= "<BR>\n";
							//$msg .= "input password" . $passwd . "<br>\n";
							//$msg .= "crypted password" . $pwd . "<br>\n";
						}
					} else {
						$sts = TRUE;
					}
					break;
				}
			}
		}
		if (!$found) {
			$msg = $userid_str . "&nbsp;" . get_txt("is different");
			$logmsg = "bad user id : " . $userid;
		}
		flock($fp, 3);
		fclose($fp);
	}
	if ($sts) {
		set_session_value("LOGIN_USER", $userid);
		put_log($conf, "Login success");
		if ($conf["CONFIG_DIR"] == 0) {
			//ե˥쥯Ȥ
			//It redirects it to the file list.
			echo get_redirect_files_JavaScriptHTML($conf);
		} else {
			//˥塼˥쥯Ȥ
			//It redirects it to a set menu.
			echo get_redirect_confmenu_JavaScriptHTML($conf);
		}
		exit;
	}
	if (!$sts) {
		put_log($conf, "Login failure : " . $logmsg);

		$return_url .= "?config=" . $conf["config"];
		$return_url .= "&" . $s_name . "=" . $s_id;

		echo "<br>" . $msg . "<br>\n";
		echo "<br>\n";

		//Σգң̤HTMLʸ
		//HTML that returns to former URL is acquired.
		echo get_return_refer_url_HTML($return_url, get_txt("back"));

		echo "<HR>";
		//裱裲ؤΥ󥯤ɽHTML
		//Link HTML to return 1 and return 2 destination is generated.
		echo get_return_url_HTML($conf);
	}
}

//ڡեåʥץࡦСCopyrightɽ-->
//Page footer(program version and Copyright display)-->
echo get_page_footer_HTML($conf);

?>
</CENTER>
</BODY>
</HTML>
